/////////////////////////////////////////////////////////////////////////////////
// $Id: installationWidget.h,v 1.3 1997/04/01 10:52:26 root Exp $	
// File  : installationWidget.h
// Author: Damyan Pepper
//
// This widget contains two sub-widgets, installOptions and packageDisplay.
// This widget is used to install packages.
/////////////////////////////////////////////////////////////////////////////////

#ifndef INSTALLATION_WIDGET
#define INSTALLATION_WIDGET

#include "../config.h"
// Qt Headers
#include <qframe.h>
#include <qlayout.h>

// ksetup headers
#include "packageInfo.h"
#include "packageDisplay.h"
#include "pkginstallOptions.h"

class pkgInterface;

class installationWidget : public QFrame
{
  Q_OBJECT;

  ///////////// METHODS ------------------------------------------------------
public:
  installationWidget(QWidget *parent=0, pkgInterface *type=0, const char *name=0);
  ~installationWidget();

  void installPackage(const char *location);

private:
  void setupWidgets(pkgInterface *type);
  ///////////// SLOTS --------------------------------------------------------
private slots:
  void finished(int refresh);
  ///////////// SIGNALS ------------------------------------------------------
signals:
  void finished(int mode, pkgInterface *interface, int refresh);
  ///////////// DATA ---------------------------------------------------------
private:
  QBoxLayout *layout;
  packageDisplayWidget *packageDisplay;
  pkgInterface *interface;
  pkginstallOptionsWidget *installOptions;
};
#endif
