///////////////////////////////////////////////////////////////////////////////
// $Id: main.cpp,v 1.6 1997/04/01 10:51:49 root Exp $	
// File  : main.cpp
// Author: Damyan Pepper
//
// This is the entry point to the program
///////////////////////////////////////////////////////////////////////////////


#include "../config.h"
#include "kpackage.h"

#include <kapp.h>

#include "debInterface.h"
#include "rpmInterface.h"

// Keep a global pointer to ksetup
KPKG *kpkg;
char *argv0;
KApplication *app;
KIconLoader  *globalKIL;

#ifdef HAVE_RPM
  const kpinterfaceN = 2;
#else
  const kpinterfaceN = 1;
#endif
pkgInterface *kpinterface[kpinterfaceN];
 
int main(int argc, char **argv)
{
  argv0 = argv[0];

  // Create the application
  app = new KApplication(argc, argv, "kpackage");
  globalKIL  = app->getIconLoader();
   
  kpinterface[0] = new DEB();
#ifdef HAVE_RPM
  kpinterface[1] = new RPM();
#endif

  if ( app->isRestored() ) {
    if (KTopLevelWidget::canBeRestored(1)) {
      kpkg = new KPKG(app->getConfig());
      kpkg->restore(1);
    }
  } else {
    // Create the main widget and show it
    kpkg = new KPKG(app->getConfig());
    kpkg->show();
  }

  if(argc == 2)			// an argument has been given
    { 
      kpkg->kp->openNetFile(argv[1]); // and install package from argument
    }
  else {			// otherwise
    if (!kpkg->prop_restart)
      kpkg->kp->setMode(KPACKAGE::Management, 0, 1); // enter management mode
  }

  int r = app->exec();		// execute the application
  return r;			// return the result
}

