// 	$Id: packageProperties.cpp,v 1.4 1997/03/21 15:08:21 root Exp $	

#include "../config.h"
#include <stdio.h>
#include "packageProperties.h"
#include "packageProperties.moc"

packagePropertiesWidget::packagePropertiesWidget(QWidget *parent,
						 const char *name)
  : QTableView(parent,name)
{
  setFrameStyle(QFrame::Sunken | QFrame::Panel);
  package=NULL;
  setTableFlags(Tbl_clipCellPainting);
  setTableFlags(Tbl_autoVScrollBar);
  setBackgroundColor(white);
  setNumCols(2);
  setNumRows(12);
}

packagePropertiesWidget::~packagePropertiesWidget()
{
}

void packagePropertiesWidget::changePackage(packageInfo *p)
{
  package = p;
  update();
  updateTableSize();
}

int packagePropertiesWidget::cellHeight(int row)
{
  int h;

  if(package)
    {
      QDictIterator<QString> it(*(package->getDict()));
      it.toFirst();
      if(it+=row)
	{
	  QPainter p0;
	  QWidget *temp0 = new QWidget(this);
	  temp0->hide();
	  p0.begin(temp0);
	  QRect r0 = p0.boundingRect(0,0,cellWidth(0), 1000, 
				   AlignLeft|AlignTop|WordBreak,
				   it.currentKey());
	  p0.end();
	  delete temp0;

	  QPainter p;
	  QWidget *temp = new QWidget(this);
	  temp->hide();
	  p.begin(temp);
	  QRect r = p.boundingRect(0,0,cellWidth(1), 1000, 
				   AlignLeft|AlignTop|WordBreak,
				   it.current()->data());
	  p.end();
	  delete temp;
	  if (r.height() > r0.height()) {
	    h = r.height();
	  } else {
	    h = r0.height();
	  }
	  return h + 2;
	}
    }
  return 0;
}

int packagePropertiesWidget::cellWidth(int col)
{
  if(col==0)
    return( width() / 4 );
  if(col==1)
    return(((width() / 4) * 3) - 23);
  return 0;
}

void packagePropertiesWidget::paintCell(QPainter *p, int row, int col)
{
  QRect r(0,0,cellWidth(col),cellHeight(row));
  // p->fillRect(r, white);

  if(package)
    {
      QDictIterator<QString> it(*(package->getDict()));
      
      it.toFirst();
      
      if(it+=row)
	{
	  if(col==0)
	    {
	      p->drawText(2,0,r.width()-4,r.height(),
			  AlignLeft|AlignTop|WordBreak,it.currentKey());
	    }
	  else
	    {
	      p->drawText(2,0,r.width(),r.height(),
			  AlignLeft|AlignTop|WordBreak,it.current()->data());
	    }
	}
      updateScrollBars();
    } 
  // p->drawLine(r.bottomLeft(),r.bottomRight());
}
