//////////////////////////////////////////////////////////////

#ifndef PKG_IFACE_H
#define PKG_IFACE_H

#include "../config.h"

class LpackageInfo;
class packageInfo;
class installationWidget;

#include <qlist.h>

#include <kiconloader.h> 
#include "packageInfo.h"

typedef struct param {
  const char *name;
  bool init;
  bool invert;
} param;

class pkgInterface: public QObject 
{
  Q_OBJECT
 
public:
  pkgInterface();
  virtual ~pkgInterface();
  
  virtual bool isType(char *buf);
  virtual void listInstalled(LpackageInfo *pki);
  virtual param *initinstallOptions();
  virtual param *inituninstallOptions();
  virtual packageInfo *getPackageInfo(char mode, const char *name);
  virtual QList<char> *getFileList(packageInfo *p);
  virtual QList<char> *depends(const char *name, int src);
  virtual QList<char> *verify(packageInfo *p, QList<char> *files);
  virtual int uninstall(int uninstallFlags, packageInfo *p);
  virtual int install(int installFlags, packageInfo *p);

  void collectDepends(packageInfo *p, const char *name, int src);

  installationWidget *installation;
  QString icon;
  QString head;
  int sizeTruncate;
  QPixmap *pict, *bad_pict;
};

extern KIconLoader  *globalKIL;
#endif





