////////////////////////////////////////////////////////////////////////////////
// $Id: pkginstallOptions.h,v 1.3 1997/04/01 10:52:26 root Exp $
// File  : pkginstallOptions.h
// Author: Damyan Pepper
//
// This provides the installation options, plus the install and cancel
// buttons.  When the install button is clicked, the current package
// is installed.
/////////////////////////////

#ifndef PKGINSTALL_OPTIONS
#define PKGINSTALL_OPTIONS

#include "../config.h"
// Qt headers
#include <qframe.h>
#include <qlayout.h>
#include <qpushbt.h>
#include <qchkbox.h>

// kpackage headers
#include "packageInfo.h"
#include "pkgInterface.h"

struct param;

class pkginstallOptionsWidget : public QFrame
{
  Q_OBJECT;
public:
  pkginstallOptionsWidget(QWidget *parent=0, param *pars=0,
			  const char *name = 0);
  ~pkginstallOptionsWidget();

  // This sets the package that the widget is dealing with
  void setPackage(packageInfo *p);

private:
  // This sets up the sub-widgets
  void setupWidgets(param *pars);

private slots:  
  void pkginstallButtonClicked();
  void cancelButtonClicked();

signals:
  // This signal indicates that the widget has finished.
  void finished(int refresh);

private:
  // Pointer to the current package
  packageInfo *package;

  // The layout manager
  QBoxLayout *layout;

  // Sub widgets
  QPushButton *installButton, *cancelButton;

  QCheckBox **Boxs;
  // options buttons

  int bnumber;
  // number of option buttons
};
#endif
