#include "../config.h"
#include "pkguninstallDialog.h"
#include "pkguninstallDialog.moc"
#include "pkgInterface.h"
#include "kpackage.h"

pkguninstallDialog::pkguninstallDialog(packageInfo *p,param *pars,
				 QWidget *parent=0, const char *name=0)
  : QDialog(parent,name,TRUE)
{
  int i;
  resize(250,150);

  package = p;
  // Create the widgets
  uninstallButton = new QPushButton(klocale->translate("Uninstall"), this);
  cancelButton = new QPushButton(klocale->translate("Cancel"), this);

  // count number of buttons
  for (i = 0; pars[i].name != 0; i++) {
    bnumber = i;
  }
  bnumber++;

  Boxs = new QCheckBox *[bnumber];
  for (i = 0; i < bnumber; i++) {
    Boxs[i] = new QCheckBox(pars[i].name, this);
    Boxs[i]->setChecked(pars[i].init);
  }

  char s[200];
  sprintf(s,klocale->translate("Uninstall: %s\n"),
	  p->getProperty("name")->data());
  label = new QLabel(s,this);


  // Connections
  connect(uninstallButton,SIGNAL(clicked()), SLOT(uninstallClicked()));
  connect(cancelButton, SIGNAL(clicked()), SLOT(cancelClicked()));

  // Create the layout managers
  QBoxLayout *buttons;
  layout = new QBoxLayout(this, QBoxLayout::TopToBottom,5,0);
  buttons = new QBoxLayout(QBoxLayout::LeftToRight);


  // Setup layout
  layout->addWidget(label,2);
  layout->addStretch(1);
  for (i = 0; i < bnumber; i++) {
    layout->addWidget(Boxs[i],1);
  }
  layout->addStretch(1);
  layout->addLayout(buttons);

  buttons->addStrut(20);
  buttons->addWidget(uninstallButton,2);
  buttons->addStretch(2);
  buttons->addWidget(cancelButton, 2);

  layout->activate();
}

pkguninstallDialog::~pkguninstallDialog()
{
  int i;
  for (i = 0; i < bnumber; i++) {
    delete(Boxs[i]);
  }
  delete uninstallButton;
  delete cancelButton;
  delete label;
  delete layout;
}

void pkguninstallDialog::uninstallClicked()
{
  int i, r, uninstallFlags=0;

  for (i = 0; i < bnumber; i++) {
    uninstallFlags |= (Boxs[i]->isChecked()) << i;
  }	

  r = package->interface->uninstall(uninstallFlags,package);

  if (r)
    reject();
  else
    accept();
}

void pkguninstallDialog::cancelClicked()
{
  reject();
}




