//////////////////////////////////////////////////////////////
// 	$Id: rpmInterface.h,v 1.4 1997/04/02 09:35:57 root Exp $	
//
// This file is being developed ad-hoc
//
// As functions that require access to RPM are needed they
// will be declared and added to this file
//////////////////////////////////////////////////////////////

#ifndef RPM_IFACE_H
#define RPM_IFACE_H

#include "../config.h"
extern "C"
{
  #include "rpmlib_new.h"
}

#include <qlist.h>
#include "packageInfo.h"
#include "pkgInterface.h"

class RPM : public pkgInterface
{
public:
  RPM();
  ~RPM();
  
  bool isType(char *buf);
  void listInstalled(LpackageInfo *pki);
  param *initinstallOptions();
  param *inituninstallOptions();
  packageInfo *getPackageInfo(char mode, const char *name);
  QList<char> *getFileList(packageInfo *p);
  QList<char> *depends(const char *name, int src);
  QList<char> *verify(packageInfo *p, QList<char> *files);
  int uninstall(int uninstallFlags, packageInfo *p);
  int install(int installFlags, packageInfo *p);
  
private:
  packageInfo* collectInfo(Header h);
  QList<char>* collectFileList(Header h);
};

#endif



